// OggVorbisMemory.h
//

#ifndef IKD_DIX_OGGVORBISMEMORY_H
#define IKD_DIX_OGGVORBISMEMORY_H

#include "OggVorbisResource.h"

namespace Dix {
	class OggVorbisMemory : public OggVorbisResource {
	public:
		OggVorbisMemory();
		OggVorbisMemory( const char* filePath );
		virtual ~OggVorbisMemory();

		//! Oggobt@쐬
		bool createBuffer( const char* filePath );

		// SȃN[쐬
		virtual sp< OggVorbisResource > createClone();

		//! NA
		virtual void clear();

	protected:
		//! ǂݍ
		static size_t read( void* buffer, size_t size, size_t maxCount, void* stream );

		//! V[N
		static int seek( void* buffer, ogg_int64_t offset, int flag );

		//! N[Y
		static int close( void* buffer );

		//! ʒuʒB
		static long tell( void* buffer );

	protected:
		char		filePath_[ 256 ];	// t@CpX
		sp< char >	spBuffer_;			// Oggt@Cobt@
		int			size_;				// obt@TCY
		long		curPos_;			// ݂̈ʒu
	};
}

#endif