// PCMDecoder.h
//

#ifndef IKD_DIX_PCMDECODER_H
#define IKD_DIX_PCMDECODER_H

#include <windows.h>
#include <mmsystem.h>
#include "DixSmartPtr.h"

namespace Dix
{
	class PCMDecoder {
	public:
		//! RXgN^
		PCMDecoder();

		//! fXgN^
		virtual ~PCMDecoder();

		//! ZOg擾
		virtual bool getSegment( char* buffer, unsigned int size, unsigned int* writeSize, bool* isEnd ) = 0;

		//! o
		virtual void setHead() = 0;

		//! SȃN[𐶐
		virtual sp< PCMDecoder > createClone() = 0;

	public:
		//! NA
		virtual void clear();

		//! [vtO擾
		bool isLoop();

		//! łH
		bool isReady();

		//! [vݒ
		void setLoop( bool isLoop );

		//! WAVEFORMATEX\̂擾
		bool getWaveFormatEx( WAVEFORMATEX& waveFormatEx );

	protected:
		//! tOݒ
		void setReady( bool isReady );

		//! `lݒ
		void setChannelNum( unsigned int channeNum );

		//! TvO[gݒ
		void setSamplingRate( unsigned int samplingRate );

		//! rbg[gݒ
		void setBitRate( unsigned int bitRate );

	protected:
		bool isLoop_;				//!< [vH
		bool isReady_;				//!< łH
		unsigned int channelNum_;	//!< `l
		unsigned int samplingRate_;	//!< TvO[g
		unsigned int bitRate_;		//!< rbg[g
	};
}

#endif