// OggDecoder.h
//

#ifndef IKD_DIX_OGGDECODER_H
#define IKD_DIX_OGGDECODER_H

#include "vorbis/vorbisfile.h"
#include "PCMDecoder.h"
#include "OggVorbisResource.h"
#include "DixSmartPtr.h"

namespace Dix {
	class OggDecoder : public PCMDecoder {
	public:
		OggDecoder();
		OggDecoder( sp< OggVorbisResource > oggVorbisResource );
		virtual ~OggDecoder();

		//! NA
		virtual void clear();

		//! ZOg擾
		virtual bool getSegment( char* buffer, unsigned int size, unsigned int* writeSize, bool* isEnd );

		//! o
		virtual void setHead();

		//! SȃN[𐶐
		virtual sp< PCMDecoder > createClone();

		//! TEhZbg
		virtual bool setResource( sp< OggVorbisResource > oggVorbisResource );

	protected:
		sp< OggVorbisResource > oggVorbisResource_;
	};
}

#endif